﻿using MVCSampleBrowser.Models;
using Syncfusion.JavaScript.DataSources;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using Syncfusion.Linq;
using System.Web;
using System.Web.Mvc;
using Syncfusion.JavaScript.Models;
using System.Web.Script.Serialization;
using System.Reflection;
using Syncfusion.EJ.Export;
using System.Net;

namespace MvcApplication66.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            ViewBag.data1 = new List<object>();
            var data = OrderRepository.GetAllRecords().ToList();
            
            return View(data);
        }
        public ActionResult EtablissementDropHandler(List<EditableOrder> added)
        {
            List<object> result = new List<object>();
            foreach (EditableOrder myEtab in added)
            {
                //PresencePraticien(myEtab.code, myEtab.libelle, 0, "", "N", "", "", "")
                result.Add(new { OrderID = myEtab.OrderID, CustomerID = myEtab.CustomerID, EmployeeID = myEtab.EmployeeID  });
            }
            return Json(result, JsonRequestBehavior.AllowGet);
        }
        public ActionResult GrdBatchUpdate(string action, List<EditableOrder> added, List<EditableOrder> changed, List<EditableOrder> deleted, int? key)
        {
            if (changed != null)
                OrderRepository.Update(changed);
            if (deleted != null)
                OrderRepository.Delete(deleted);
            if (added != null)
            {
                for (int i = 0; i < added.Count(); i++)
                {
                    EditableOrder order = OrderRepository.GetAllRecords().Where(ord => ord.OrderID == added[i].OrderID).FirstOrDefault();
                    if (order != null)
                        throw new InvalidOperationException("OrderID already exist");//Exception thrown
                }
                OrderRepository.Add(added);
            }
            var data = OrderRepository.GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        public ActionResult DataSource(Syncfusion.JavaScript.DataManager dm)
        {
            IEnumerable Data = OrderRepository.GetAllRecords().ToList();
            DataResult result = new DataResult();
            DataOperations operation = new DataOperations();
            if (dm.Where != null)
            {
                Data = operation.PerformWhereFilter(Data, dm.Where, dm.Where[0].Condition);
            }

            result.count = Data.AsQueryable().Count();
            if (dm.Skip != null)
                Data = operation.PerformSkip(Data, dm.Skip);
            if (dm.Take != null)
                Data = operation.PerformTake(Data, dm.Take);
            result.result = Data;
            return Json(result, JsonRequestBehavior.AllowGet);
        }
        public class DataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
        }
    }
}